/*----- PROTECTED REGION ID(SeqUtils.h) ENABLED START -----*/
//=============================================================================
//
// file :        SeqUtils.h
//
// description : Include file for the SeqUtils class
//
// project :     SeqUtils
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SeqUtils_H
#define SeqUtils_H

#include <tango.h>


/*----- PROTECTED REGION END -----*/	//	SeqUtils.h

/**
 *  SeqUtils class description:
 *    It returns a random generated number, sec/nsec date
 */

namespace SeqUtils_ns
{
/*----- PROTECTED REGION ID(SeqUtils::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	SeqUtils::Additional Class Declarations

class SeqUtils : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(SeqUtils::Data Members) ENABLED START -----*/

//	Add your own data members

/*----- PROTECTED REGION END -----*/	//	SeqUtils::Data Members


//	Attribute data members
public:
	Tango::DevDouble	*attr_DRand_read;
	Tango::DevDouble	*attr_DRandMin_read;
	Tango::DevDouble	*attr_DRandMax_read;
	Tango::DevLong	*attr_LRand_read;
	Tango::DevLong	*attr_LRandMin_read;
	Tango::DevLong	*attr_LRandMax_read;
	Tango::DevDouble	*attr_Data_read;
	Tango::DevDouble	*attr_Data1_read;
	Tango::DevLong	*attr_LData_read;
	Tango::DevLong	*attr_Date_read;
	Tango::DevLong	*attr_LDate_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	SeqUtils(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	SeqUtils(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	SeqUtils(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~SeqUtils() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : SeqUtils::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : SeqUtils::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute DRand related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DRand(Tango::Attribute &attr);
	virtual bool is_DRand_allowed(Tango::AttReqType type);
/**
 *	Attribute DRandMin related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DRandMin(Tango::Attribute &attr);
	virtual void write_DRandMin(Tango::WAttribute &attr);
	virtual bool is_DRandMin_allowed(Tango::AttReqType type);
/**
 *	Attribute DRandMax related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_DRandMax(Tango::Attribute &attr);
	virtual void write_DRandMax(Tango::WAttribute &attr);
	virtual bool is_DRandMax_allowed(Tango::AttReqType type);
/**
 *	Attribute LRand related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_LRand(Tango::Attribute &attr);
	virtual bool is_LRand_allowed(Tango::AttReqType type);
/**
 *	Attribute LRandMin related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_LRandMin(Tango::Attribute &attr);
	virtual void write_LRandMin(Tango::WAttribute &attr);
	virtual bool is_LRandMin_allowed(Tango::AttReqType type);
/**
 *	Attribute LRandMax related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_LRandMax(Tango::Attribute &attr);
	virtual void write_LRandMax(Tango::WAttribute &attr);
	virtual bool is_LRandMax_allowed(Tango::AttReqType type);
/**
 *	Attribute Data related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Data(Tango::Attribute &attr);
	virtual void write_Data(Tango::WAttribute &attr);
	virtual bool is_Data_allowed(Tango::AttReqType type);
/**
 *	Attribute Data1 related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Data1(Tango::Attribute &attr);
	virtual void write_Data1(Tango::WAttribute &attr);
	virtual bool is_Data1_allowed(Tango::AttReqType type);
/**
 *	Attribute LData related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_LData(Tango::Attribute &attr);
	virtual void write_LData(Tango::WAttribute &attr);
	virtual bool is_LData_allowed(Tango::AttReqType type);
/**
 *	Attribute Date related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Spectrum max = 2
 */
	virtual void read_Date(Tango::Attribute &attr);
	virtual bool is_Date_allowed(Tango::AttReqType type);
/**
 *	Attribute LDate related methods
 *	Description: 
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Spectrum max = 2
 */
	virtual void read_LDate(Tango::Attribute &attr);
	virtual bool is_LDate_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : SeqUtils::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command On related method
	 *	Description: 
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);
	/**
	 *	Command Off related method
	 *	Description: 
	 *
	 */
	virtual void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *	Description: 
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command SetFault related method
	 *	Description: 
	 *
	 */
	virtual void set_fault();
	virtual bool is_SetFault_allowed(const CORBA::Any &any);
	/**
	 *	Command Start related method
	 *	Description: 
	 *
	 */
	virtual void start();
	virtual bool is_Start_allowed(const CORBA::Any &any);
	/**
	 *	Command Stop related method
	 *	Description: 
	 *
	 */
	virtual void stop();
	virtual bool is_Stop_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : SeqUtils::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(SeqUtils::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	SeqUtils::Additional Method prototypes
};

/*----- PROTECTED REGION ID(SeqUtils::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	SeqUtils::Additional Classes Definitions

}	//	End of namespace

#endif   //	SeqUtils_H
