/*----- PROTECTED REGION ID(SeqUtilsClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        SeqUtilsClass.h
//
// description : Include for the SeqUtils root class.
//               This class is the singleton class for
//                the SeqUtils device class.
//               It contains all properties and methods which the 
//               SeqUtils requires only once e.g. the commands.
//
// project :     SeqUtils
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef SeqUtilsClass_H
#define SeqUtilsClass_H

#include <tango.h>
#include <SeqUtils.h>


/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass.h


namespace SeqUtils_ns
{
/*----- PROTECTED REGION ID(SeqUtilsClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute DRand class definition
class DRandAttrib: public Tango::Attr
{
public:
	DRandAttrib():Attr("DRand",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~DRandAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_DRand(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_DRand_allowed(ty);}
};

//	Attribute DRandMin class definition
class DRandMinAttrib: public Tango::Attr
{
public:
	DRandMinAttrib():Attr("DRandMin",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DRandMinAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_DRandMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_DRandMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_DRandMin_allowed(ty);}
};

//	Attribute DRandMax class definition
class DRandMaxAttrib: public Tango::Attr
{
public:
	DRandMaxAttrib():Attr("DRandMax",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DRandMaxAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_DRandMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_DRandMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_DRandMax_allowed(ty);}
};

//	Attribute LRand class definition
class LRandAttrib: public Tango::Attr
{
public:
	LRandAttrib():Attr("LRand",
			Tango::DEV_LONG, Tango::READ) {};
	~LRandAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_LRand(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_LRand_allowed(ty);}
};

//	Attribute LRandMin class definition
class LRandMinAttrib: public Tango::Attr
{
public:
	LRandMinAttrib():Attr("LRandMin",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~LRandMinAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_LRandMin(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_LRandMin(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_LRandMin_allowed(ty);}
};

//	Attribute LRandMax class definition
class LRandMaxAttrib: public Tango::Attr
{
public:
	LRandMaxAttrib():Attr("LRandMax",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~LRandMaxAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_LRandMax(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_LRandMax(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_LRandMax_allowed(ty);}
};

//	Attribute Data class definition
class DataAttrib: public Tango::Attr
{
public:
	DataAttrib():Attr("Data",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DataAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_Data(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_Data(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_Data_allowed(ty);}
};

//	Attribute Data1 class definition
class Data1Attrib: public Tango::Attr
{
public:
	Data1Attrib():Attr("Data1",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~Data1Attrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_Data1(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_Data1(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_Data1_allowed(ty);}
};

//	Attribute LData class definition
class LDataAttrib: public Tango::Attr
{
public:
	LDataAttrib():Attr("LData",
			Tango::DEV_LONG, Tango::READ_WRITE) {};
	~LDataAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_LData(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<SeqUtils *>(dev))->write_LData(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_LData_allowed(ty);}
};

//	Attribute Date class definition
class DateAttrib: public Tango::SpectrumAttr
{
public:
	DateAttrib():SpectrumAttr("Date",
			Tango::DEV_LONG, Tango::READ, 2) {};
	~DateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_Date(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_Date_allowed(ty);}
};

//	Attribute LDate class definition
class LDateAttrib: public Tango::SpectrumAttr
{
public:
	LDateAttrib():SpectrumAttr("LDate",
			Tango::DEV_LONG, Tango::READ, 2) {};
	~LDateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<SeqUtils *>(dev))->read_LDate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<SeqUtils *>(dev))->is_LDate_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OnClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OnClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SeqUtils *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	OffClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~OffClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SeqUtils *>(dev))->is_Off_allowed(any);}
};

//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	ResetClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~ResetClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SeqUtils *>(dev))->is_Reset_allowed(any);}
};

//	Command SetFault class definition
class SetFaultClass : public Tango::Command
{
public:
	SetFaultClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetFaultClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetFaultClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SeqUtils *>(dev))->is_SetFault_allowed(any);}
};

//	Command Start class definition
class StartClass : public Tango::Command
{
public:
	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StartClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SeqUtils *>(dev))->is_Start_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<SeqUtils *>(dev))->is_Stop_allowed(any);}
};


/**
 *	The SeqUtilsClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  SeqUtilsClass : public Tango::DeviceClass
#else
class SeqUtilsClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(SeqUtilsClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	SeqUtilsClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static SeqUtilsClass *init(const char *);
		static SeqUtilsClass *instance();
		~SeqUtilsClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		SeqUtilsClass(string &);
		static SeqUtilsClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	SeqUtils_H
